export declare type ProgressType = 'global' | 'session';
export interface GetLeetcodeProgressOptions {
    leetcodeGraphqlUrl?: string;
    /**
     * `graphql-request` defaults to use `cross-fetch` which depends on
     * XMLHttpRequest in a browser-like environment.
     *
     * Override it to the Cloudflare-implemented `WindowOrWorkerGlobalScope.fetch`
     * by default since Cloudflare Worker runtime does not support XMLHttpRequest.
     */
    fetch?: typeof fetch;
}
export interface ProblemCount {
    all: number;
    easy: number;
    medium: number;
    hard: number;
}
export interface ProblemCountArrayItem {
    difficulty: keyof ProblemCount;
    count: number;
}
export interface LeetcodeProgress {
    username: string;
    total: ProblemCount;
    ac: ProblemCount;
}
export declare function reduceProblemCountArray(arr?: ProblemCountArrayItem[]): ProblemCount;
export declare function fetchProgress(username: string, progressType: ProgressType, { leetcodeGraphqlUrl, fetch: _fetch, }?: GetLeetcodeProgressOptions): Promise<LeetcodeProgress>;
export declare const renderProgress: (data: unknown[] | Record<string, any>, options?: import("pupa").Options | undefined) => string;
